#include <stdlib.h>
#include <string.h>
static void swap(void *a, void *b, size_t size)
{
    char *temp=(char *)malloc(size);
    memmove(temp, a, size);
    memmove(a, b, size);
    memmove(b, temp, size);
    free(temp);
}
void bubble(void *p, int (*compare)(void *a, void *b), int N, size_t size)
{
 int i, j;
 for(i = N-1; i >= 0; i--)
   for(j = 1; j <= i; j++)
     if (compare((void *)(p + (j - 1) * size), (void *)(p + j * size)) > 0)
       {
           swap((void *)(p + (j - 1) * size), (void *)(p + j * size), size);
       }
}
